JUCE: WebInputStream Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Classes | Public Member Functions | List of all members
WebInputStream Class Reference
juce_core » network

An InputStream which can be used to read from a given URL. More...

`#include <juce_WebInputStream.h>`

Inheritance diagram for WebInputStream:

## Classes
class | Listener
| Used to receive callbacks for POST data send progress. More...

## Public Member Functions
| WebInputStream (const URL &url, bool addParametersToRequestBody)
| Creates a new WebInputStream which can be used to read from a URL.
| ~WebInputStream () override
| Destructor.
WebInputStream & | withExtraHeaders (const String &extraHeaders)
| Add extra headers to the HTTP request.
WebInputStream & | withCustomRequestCommand (const String &customRequestCommand)
| Override the HTTP command that is sent.
WebInputStream & | withConnectionTimeout (int timeoutInMs)
| Specify the connection time-out.
WebInputStream & | withNumRedirectsToFollow (int numRedirects)
| Specify the number of redirects to be followed.
bool | connect (Listener *listener)
| Wait until the first byte is ready for reading.
bool | isError () const
| Returns true if there was an error during the connection attempt.
void | cancel ()
| Will cancel a blocking read and prevent any subsequent connection attempts.
StringPairArray | getRequestHeaders () const
| Returns a StringPairArray of the request headers.
StringPairArray | getResponseHeaders ()
| Returns a StringPairArray of response headers.
int | getStatusCode ()
| Returns the status code returned by the HTTP server.
int64 | getTotalLength () override
| Returns the total number of bytes available for reading in this stream.
int | read (void *destBuffer, int maxBytesToRead) override
| Reads some data from the stream into a memory buffer.
bool | isExhausted () override
| Returns true if the stream has no more data to read.
int64 | getPosition () override
| Returns the offset of the next byte that will be read from the stream.
bool | setPosition (int64 wantedPos) override
| Tries to move the current read position of the stream.
Public Member Functions inherited from InputStream
virtual | ~InputStream ()=default
| Destructor.
int64 | getNumBytesRemaining ()
| Returns the number of bytes available for reading, or a negative value if the remaining length is not known.
ssize_t | read (void *destBuffer, size_t maxBytesToRead)
virtual char | readByte ()
| Reads a byte from the stream.
virtual bool | readBool ()
| Reads a boolean from the stream.
virtual short | readShort ()
| Reads two bytes from the stream as a little-endian 16-bit value.
virtual short | readShortBigEndian ()
| Reads two bytes from the stream as a little-endian 16-bit value.
virtual int | readInt ()
| Reads four bytes from the stream as a little-endian 32-bit value.
virtual int | readIntBigEndian ()
| Reads four bytes from the stream as a big-endian 32-bit value.
virtual int64 | readInt64 ()
| Reads eight bytes from the stream as a little-endian 64-bit value.
virtual int64 | readInt64BigEndian ()
| Reads eight bytes from the stream as a big-endian 64-bit value.
virtual float | readFloat ()
| Reads four bytes as a 32-bit floating point value.
virtual float | readFloatBigEndian ()
| Reads four bytes as a 32-bit floating point value.
virtual double | readDouble ()
| Reads eight bytes as a 64-bit floating point value.
virtual double | readDoubleBigEndian ()
| Reads eight bytes as a 64-bit floating point value.
virtual int | readCompressedInt ()
| Reads an encoded 32-bit number from the stream using a space-saving compressed format.
virtual String | readNextLine ()
| Reads a UTF-8 string from the stream, up to the next linefeed or carriage return.
virtual String | readString ()
| Reads a zero-terminated UTF-8 string from the stream.
virtual String | readEntireStreamAsString ()
| Tries to read the whole stream and turn it into a string.
virtual size_t | readIntoMemoryBlock (MemoryBlock &destBlock, ssize_t maxNumBytesToRead=-1)
| Reads from the stream and appends the data to a MemoryBlock.
virtual void | skipNextBytes (int64 numBytesToSkip)
| Reads and discards a number of bytes from the stream.

## Additional Inherited Members
Protected Member Functions inherited from InputStream
| InputStream ()=default

## Detailed Description

An InputStream which can be used to read from a given URL.

## Constructor & Destructor Documentation

## ◆ WebInputStream()

WebInputStream::WebInputStream | ( | const URL & | url,
|  | bool | addParametersToRequestBody
| ) |  |

Creates a new WebInputStream which can be used to read from a URL.

Parameters

  url | the URL that should be retrieved. This parameter may also contain POST data and/or parameters.
  addParametersToRequestBody | specifies whether any URL parameters that have been set will be transferred via the request body data or added to the URL address. This will also determine whether a POST or GET command will be used if a custom command is not set.

## ◆ ~WebInputStream()

WebInputStream::~WebInputStream | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ withExtraHeaders()

WebInputStream & WebInputStream::withExtraHeaders | ( | const String & | extraHeaders | ) |

Add extra headers to the HTTP request.

Returns a reference to itself so that several methods can be chained.

Parameters

  extraHeaders | this string is appended onto the headers that are used for the request. It must therefore be a valid set of HTML header directives, separated by newlines.

## ◆ withCustomRequestCommand()

WebInputStream & WebInputStream::withCustomRequestCommand | ( | const String & | customRequestCommand | ) |

Override the HTTP command that is sent.

Returns a reference to itself so that several methods can be chained.

Note that this command will not change the way parameters are sent. This must be specified in the constructor.

Parameters

  customRequestCommand | this string is the custom HTTP request command such as POST or GET.

## ◆ withConnectionTimeout()

WebInputStream & WebInputStream::withConnectionTimeout | ( | int | timeoutInMs | ) |

Specify the connection time-out.

Returns a reference to itself so that several methods can be chained.

Parameters

  timeoutInMs | the number of milliseconds to wait until the connection request is aborted.

## ◆ withNumRedirectsToFollow()

WebInputStream & WebInputStream::withNumRedirectsToFollow | ( | int | numRedirects | ) |

Specify the number of redirects to be followed.

Returns a reference to itself so that several methods can be chained.

Parameters

  numRedirects | specifies the number of redirects that will be followed before returning a response (ignored for Android which follows up to 5 redirects)

## ◆ connect()

bool WebInputStream::connect | ( | Listener * | listener | ) |

Wait until the first byte is ready for reading.

This method will attempt to connect to the URL given in the constructor and block until the status code and all response headers have been received or an error has occurred.

Note that most methods will call connect() internally if they are called without an established connection. Therefore, it is not necessary to explicitly call connect unless you would like to use a custom listener.

After a successful call to connect(), getResponseHeaders(), getTotalLength() and getStatusCode() will all be non-blocking.

Parameters

  listener | a listener to receive progress callbacks on the status of a POST data upload.

See also
  getResponseHeaders, getTotalLength, getStatusCode

## ◆ isError()

bool WebInputStream::isError | ( |  | ) | const

Returns true if there was an error during the connection attempt.

## ◆ cancel()

void WebInputStream::cancel | ( |  | ) |

Will cancel a blocking read and prevent any subsequent connection attempts.

## ◆ getRequestHeaders()

StringPairArray WebInputStream::getRequestHeaders | ( |  | ) | const

Returns a StringPairArray of the request headers.

## ◆ getResponseHeaders()

StringPairArray WebInputStream::getResponseHeaders | ( |  | ) |

Returns a StringPairArray of response headers.

If getResponseHeaders() is called without an established connection, then getResponseHeaders() will call connect internally and block until connect returns - either due to a successful connection or a connection error.

See also
  connect

## ◆ getStatusCode()

int WebInputStream::getStatusCode | ( |  | ) |

Returns the status code returned by the HTTP server.

If getStatusCode() is called without an established connection, then getStatusCode() will call connect internally and block until connect returns - either due to a successful connection or a connection error.

See also
  connect

## ◆ getTotalLength()

int64 WebInputStream::getTotalLength | ( |  | ) |
| overridevirtual

Returns the total number of bytes available for reading in this stream.

Note that this is the number of bytes available from the start of the stream, not from the current position.

If getTotalLength() is called without an established connection, then getTotalLength() will call connect internally and block until connect returns - either due to a successful connection or a connection error.

If the size of the stream isn't actually known, this will return -1.

Implements InputStream.

## ◆ read()

int WebInputStream::read | ( | void * | destBuffer,
|  | int | maxBytesToRead
| ) |  |
| overridevirtual

Reads some data from the stream into a memory buffer.

This method will block until the maxBytesToRead bytes are available.

This method calls connect() internally if the connection hasn't already been established.

Parameters

  destBuffer | the destination buffer for the data. This must not be null.
  maxBytesToRead | the maximum number of bytes to read - make sure the memory block passed in is big enough to contain this many bytes. This value must not be negative.

Returns
  the actual number of bytes that were read, which may be less than maxBytesToRead if the stream is exhausted before it gets that far

Implements InputStream.

## ◆ isExhausted()

bool WebInputStream::isExhausted | ( |  | ) |
| overridevirtual

Returns true if the stream has no more data to read.

Implements InputStream.

## ◆ getPosition()

int64 WebInputStream::getPosition | ( |  | ) |
| overridevirtual

Returns the offset of the next byte that will be read from the stream.

See also
  setPosition

Implements InputStream.

## ◆ setPosition()

bool WebInputStream::setPosition | ( | int64 | wantedPos | ) |
| overridevirtual

Tries to move the current read position of the stream.

The position is an absolute number of bytes from the stream's start.

For a WebInputStream, this method will fail if wantedPos is smaller than the current position. If wantedPos is greater than the current position, then calling setPosition() is the same as calling read(), i.e. the skipped data will still be downloaded, although skipped bytes will be discarded immediately.

Returns
  true if the stream manages to reposition itself correctly

See also
  getPosition

Implements InputStream.

The documentation for this class was generated from the following file:

- juce_WebInputStream.h